/*
 * Copyright (C) 2021 Zorin OS Technologies Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef XFCE4_ZORIN_APPGRID_LITE_PLUGIN_H
#define XFCE4_ZORIN_APPGRID_LITE_PLUGIN_H

#define PLUGIN_WEBSITE "https://zorin.com/os/"

#include <string>

#include <gtk/gtk.h>
#include <libxfce4panel/libxfce4panel.h>

namespace Xfce4ZorinAppGridLitePlugin
{

class Plugin
{
public:
	explicit Plugin(XfcePanelPlugin* plugin);
	~Plugin();

	GtkWidget* get_button() const
	{
		return m_button;
	}

	void reload();
	void set_loaded(bool loaded);

private:
	void button_clicked(GtkButton* button);
	void configure();
	void mode_changed(XfcePanelPlugin*, XfcePanelPluginMode);
	void show_about();
	gboolean size_changed(XfcePanelPlugin*, gint size);
	void update_size();

private:
	XfcePanelPlugin* m_plugin;

	GtkWidget* m_button;
	GtkBox* m_button_box;
	GtkLabel* m_button_label;
	GtkImage* m_button_icon;
};

}

#endif // XFCE4_ZORIN_APPGRID_LITE_PLUGIN_H
